package com.keyboard.themes.key.daapter;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.keyboard.themes.key.R;
import com.keyboard.themes.key.data.MyData;
import com.keyboard.themes.key.utils.MyUtils;
import com.keyboard.themes.key.api.CancelLikeCallback;
import com.keyboard.themes.key.activity.ApplyActivity;

import java.util.ArrayList;
import java.util.List;

public class AdapterLiked extends RecyclerView.Adapter<AdapterLiked.ForYouViewHolder> {

    private Context mContext;
    private List<MyData> mList = new ArrayList<>();

    private CancelLikeCallback mCallBack;

    public AdapterLiked(Context context) {
        mContext = context;
    }

    public void setForYouList(List<MyData> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setRemoveLike(CancelLikeCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.theme_item_like, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        MyData myData = mList.get(position);
        String thumbGif = myData.getThumbGif();
        String thumb = myData.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            MyUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }
        holder.itemFavorite.setSelected(true);
        holder.layoutFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.itemFavorite.setSelected(false);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);
                if (mCallBack != null) {
                    mCallBack.OnRemoveLike(myData);
                }
            }
        });
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ApplyActivity.class);
                intentApply.putExtra(ApplyActivity.SOURCE_KEY, myData);
                intentApply.putExtra(ApplyActivity.DISPLAY_URL_KEY, myData.getImgPath());
                intentApply.putExtra(ApplyActivity.ZIP_URL_KEY, myData.getZipPath());
                intentApply.putExtra(ApplyActivity.NAME_KEY, myData.getTitleName());
                intentApply.putExtra(ApplyActivity.GIF_KEY, myData.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(ApplyActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private FrameLayout layoutFavorite;
        private ImageView itemImg, itemFavorite;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            layoutFavorite = itemView.findViewById(R.id.layout_favorite);
            itemImg = itemView.findViewById(R.id.im);
            itemFavorite = itemView.findViewById(R.id.im_favorite);

        }

    }

}
